/*------------------------------------------------------------------------------

Copyright 2011 University of Aveiro, Portugal, All Rights Reserved.

These programs are supplied free of charge for research purposes only,
and may not be sold or incorporated into any commercial product. There is
ABSOLUTELY NO WARRANTY of any sort, nor any undertaking that they are
fit for ANY PURPOSE WHATSOEVER. Use them at your own risk. If you do
happen to find a bug, or have modifications to suggest, please report
the same to Armando J. Pinho, ap@ua.pt. The copyright notice above
and this statement of conditions must remain an integral part of each
and every copy made of these files.

------------------------------------------------------------------------------*/

#ifndef SEQS_H_INCLUDED
#define SEQS_H_INCLUDED

#define SEQUENCE_LEFT_GUARD 100
#define SEQUENCE_REALLOC_SIZE 1000000
#define INVALID_SYMBOL 255

typedef struct
	{
	Base		*bases;
	unsigned	size;
	unsigned	usage[256];
	}
Sequence;

typedef struct
	{
	Symbol		symbols[256];	/* base -> symbol */
	unsigned	nSymbols;		/* Number of coding (target seq) symbols */
	Symbol		hSymbols[256];	/* base -> hSymbol */
	unsigned	nHSymbols;		/* Number of hashing symbols */
	Base		*revMap;		/* symbol -> base */
	double		*probs;			/* symbol -> probs */
	Base		caseConv[256];	/* base -> base */
	}
Alphabet;

/*----------------------------------------------------------------------------*/

Sequence *CreateSequence(unsigned seqSize);
Sequence *ReadSequence(char *fName);
void AssignHSymbols(Alphabet *alphabet);
void SetupCaseConv(Alphabet *alphabet);
unsigned GetKey(Base *bases, unsigned keySize, Alphabet *alphabet);

#endif /* SEQS_H_INCLUDED */

